ifndef TOPDIR
# not doing regress for ninja.
#platformregress=1
endif
TOPDIR?=..
PLATFORMDIR?=.
EXTRACLEAN+=cache*.mk build.timing ${TOPDIR}/build
RMFLAGS=-r

build: ${TOPDIR}/${BUILDPATH} depend in-file all regress

include ${PLATFORMDIR}/mk/all.mk

ifndef platformregress
ifneq ($(subst regress,,${MAKECMDGOALS}),${MAKECMDGOALS})
SUBDIR:=
else
SUBDIR:=lib bin modules scripts
endif
else
SUBDIR:=lib bin modules scripts regress
endif

include ${PLATFORMDIR}/mk/subdir.mk

.PHONY: tags
tags:
	ctags -R ${SUBDIR}

.PHONY: valgrind-report
valgrind-report:
	make -C regress regress-valgrind-report

.PHONY: hudson
hudson::
	make cleandir
	make JUNITXML=1 REGRESS_LOGERR_FILE=$(shell cd ${TOPDIR}; pwd)/errors.regress build

.PHONY: kill
kill::
	@pkill -u ${USER} search; \
	pkill -u ${USER} trans; \
	pkill -u ${USER} memcheck; \
	pkill -u ${USER} httpd; \
	pkill -u ${USER} bconfd; \
	pkill -u ${USER} postgres; \
	pkill -u ${USER} pgqd; \
	pkill -u ${USER} indexer; \
	pkill -u ${USER} nc; \
	pkill -u ${USER} redis-server; \
	true
	rm -f .*.lock
	rm -f .*pid
	rm -rf "${REGRESS_PGSQL_HOST}"
	@for i in $$(seq 1 10); do \
		pids=$$(lsof -nP -u ${USER} | grep -E -w $$(echo ${GENPORT_BASE}|cut -b 1-3)'[0-9][0-9] \(LISTEN|/dev/shm/regress' | awk '{ print $$2; }'); \
		[ -z "$$pids" ] && echo && exit 0; \
		echo -n .; \
		sleep 0.5; \
	done; \
	echo; \
	echo "Waiting for"; \
	ps -p $$pids; \
	kill $$pids; \
	for i in $$(seq 1 10); do \
		pids=$$(lsof -nP -u ${USER} | grep -E -w $$(echo ${GENPORT_BASE}|cut -b 1-3)'[0-9][0-9] \(LISTEN|/dev/shm/regress' | awk '{ print $$2; }'); \
		[ -z "$$pids" ] && echo && exit 0; \
		echo -n .; \
		sleep 0.5; \
	done; \
	echo; \
	echo "kill -KILL $$pids"; \
	kill -KILL $$pids

